/*
 * MainScren 
 * by PhilFlash - http://philflash.inway.fr
 * 
 * version 1.1 :  7 Oct 2005 : updated for Flash 8
 * version 1.0 : 29 Dec 2003 : version initiale
 */

import mx.controls.Button;
import mx.controls.Label;
import mx.controls.List;
import mx.controls.TextInput;
import mx.controls.TextArea;
import mx.screens.Screen;
import mx.controls.DataGrid;
import mx.controls.gridclasses.DataGridColumn;
import mx.controls.Alert;
import mx.data.components.DataSet;
import mx.data.components.datasetclasses.DataSetError;
import mx.utils.Delegate;

class MainForm extends mx.screens.Form {

	public var addButton:Button;
	public var deleteButton:Button;
	public var saveButton:Button;
	public var generateButton:Button;
	public var sendButton:Button;
	
	public var saveLocalButton:Button;
	public var readLocalButton:Button;
	public var reloadButton:Button;
	
	public var contact_grd:DataGrid;
	
	public var server_ta:TextArea;
	public var info_ta:TextArea;
	
	// Constructor
	public function MainForm() {}
	

	public function init():Void {
		super.init();
		addEventListener("reveal", onReveal);	
	}

	// -----   ----- 	
	public function onLoad(obj:Object):Void {
		setVisible(true);
		
		addButton.addEventListener("click", Delegate.create(this, doAddAction));
		deleteButton.addEventListener("click", Delegate.create(this, doDeleteAction));
		
		saveButton.addEventListener("click", Delegate.create(this, doSaveAction));
		generateButton.addEventListener("click", Delegate.create(this, doGenerateAction));
		sendButton.addEventListener("click", Delegate.create(this, doSendAction));
		
		saveLocalButton.addEventListener("click", Delegate.create(this, doWriteLocalAction));
		readLocalButton.addEventListener("click", Delegate.create(this, doReadLocalAction));	
		reloadButton.addEventListener("click", Delegate.create(this, doReloadAction));
		
		contact_grd.columnNames = [ "id_contact", "name", "email", "phone"];
		
		//customize columns
		var col:mx.controls.gridclasses.DataGridColumn;
		
		col = contact_grd.getColumnAt(0);
		col.width = 30;
		col.headerText = "Id";

		col = contact_grd.getColumnAt(1);
		col.width = 120;
		col.headerText = "Name:";
		
		col = contact_grd.getColumnAt(2);
		col.width = 120;
		col.headerText = "Email:";

		col = contact_grd.getColumnAt(3);
		col.width = 150;
		col.headerText = "Phone:";
		
		// -- Change URL --
		var siteURL;
    	if (_url.substr(0, 7) == "http://") {
			siteURL = "";
		} else {
			siteURL= "http://localhost/contactphp/";
		}
		(rootForm).contact_con.URL = siteURL+"getdata.php";
		(rootForm).save_con.URL = siteURL+"savedata.php";
	}
	
	// ----- Reveal -----
	public function onReveal(obj:Object):Void {
		(rootForm).contact_con.addEventListener("status",this);
		
		// Trigger sur config
		(rootForm).contact_con.trigger();
		(rootForm).contact_ds.addEventListener("modelChanged", Delegate.create(this, modelChangedContactAction));
	}

	// ----- Status -----
	public function status(stat:Object):Void {
		//server_ta.text += " \r---------\rXML STATUS :"+stat.code;  
		if (stat.code != "StatusChange") {
			server_ta.text += "\r------------------\rConnector STATUS - " + stat.target._name + "/" + stat.code + "/" + stat.data.faultcode + "/" + stat.data.faultstring;
		}	
	
		
	}
	
	// ----- Add Action -----
	public function doAddAction():Void {
		contact_grd.addItem({id_contact:0, name:"", email:"", phone:""});
		contact_grd.vPosition = contact_grd.length-1;
	}
	
	// ----- Delete Action -----
	public function doDeleteAction(eventObj:Object):Void {
		var item = (rootForm).contact_ds.currentItem;
		if (item.id_contact == 0 && item.name == "" && item.email == "" && item.phone == "") {
			// empty contact: delete without confirmation
			(rootForm).contact_ds.removeItem();
		} else {
			// confirmation by user
			var name:String = (item.name != "" ? item.name : (item.email+":"+item.phone));
			var message:String = "Remove '"+name+"'. Are you sure ?";
			var confirm:Alert = Alert.show(message, "Remove           ", Alert.OK | Alert.CANCEL, this, this.confirmDeleteHandler);
			confirm.owner = this;
			setLocationRelativeTo(confirm, eventObj.target);	
		}
	}	
	
	private function confirmDeleteHandler(eventObj:Object):Void {
		var detail = eventObj.detail;
		var target = eventObj.target;
		if (detail == Alert.OK || detail == Alert.YES) {
			target.owner.rootForm.contact_ds.removeItem();
		}
	
	}
	// ----- Save -----
	public function doSaveAction(eventObj:Object):Void {
		var dataset:DataSet = (rootForm).contact_ds;	
		server_ta.text = "Waiting server response...";
		dataset.applyUpdates();
		(rootForm).save_con.trigger();
		
	}
		
	// ----- Generate and Send -----
	public function doGenerateAction(eventObj:Object):Void {
		server_ta.text = "";	
		(rootForm).contact_ds.applyUpdates();
	}	
	
	public function doSendAction(eventObj:Object):Void {
		server_ta.text = "Waiting server response...";
		(rootForm).save_con.trigger();
	}

	// ----- Write and Read SharedObject Action -----
	public function doWriteLocalAction(eventObj:Object):Void {
		var dataset:DataSet = (rootForm).contact_ds;	
		try {
			dataset.saveToSharedObj("SiteLocal");
		}
		catch(e:DataSetError) {
			trace("Unable to create shared object");
		}
	}
	
	public function doReadLocalAction(eventObj:Object):Void {
		var dataset:DataSet = (rootForm).contact_ds;	
		try {
			dataset.loadFromSharedObj("SiteLocal");
		}
		catch(e:DataSetError) {
			trace("Unable to load shared object."); 
		}
	}
	
	// ----- Reload Action -----
	public function doReloadAction(eventObj:Object):Void {
		server_ta.text = "";
		info_ta.text = "";
		(rootForm).contact_con.trigger();	
	}
	
	
	// ----- modelChanged Action -----
	public function modelChangedContactAction(eventObj:Object):Void {
		refreshButtons();
	}
	
	// -----  -----
	public function refreshButtons():Void {
		var dataset:DataSet = (rootForm).contact_ds;
		var len:Number = dataset.length;
		
		deleteButton.enabled = (len != 0);
		saveButton.enabled = dataset.changesPending();
	}
	
	// -----  -----
	function setLocationRelativeTo(mc:MovieClip, owner:Object) {
		var x0:Number = 0;
		var y0:Number = 0;
		if (owner != undefined && owner instanceof MovieClip) {
			x0 = owner._x+(owner._width/2);
			y0 = owner._y+(owner._height/2);	
			var x:Number = x0 - mc._width/2;
			var y:Number = y0 - mc._height/2;
			if (x < 0) {
				x = 0;
			}
			if (y < 0) {
				y = 0;
			}
			if (x + mc._width > Stage.width) {
				x = Stage.width - mc._width;
			}
			if (y + mc._height > Stage.height) {
				y = Stage.height - mc.height;
			}

			mc.move(x,y);		
		} else {
			mc.move((Stage.width-mc._width)/2, (Stage.height-mc._height)/2);	
		}
	}
}
    

